100 REM PINGing around with a Propeller BOE-BOT
105 REM PING))) plugged into servo header for I/O pin 14
110 REM Ping servo [15] (R) 550 to (L) 2300, (C) 1425
120 REM Left servo [16] (F) > 1700, (C) 1486, (R) < 1300
130 REM Right servo [17] (F) < 1300, (C) 1508, (R) > 1700
140 SERVO[15] = 1425 : REM Initialize
145 SERVO[16] = 1486 : SERVO[17] = 1508
150 PAUSE 500
160 GOSUB 1000 : REM Look around with PING
230 f = 0 : g = 300 : REM Which direction has longer path
240 IF a > f THEN f = a : g = 400
250 IF b > f THEN f = b : g = 500
260 IF c > f THEN f = c : g = 600
270 IF d > f THEN f = d : g = 700
280 IF e > f THEN f = e : g = 800
285 PRINT "Longest distance ";f
290 GOTO g
300 REM No responses in any direction
305 PRINT "No response, go forward"
310 GOSUB 1500 : REM Go forward
320 GOSUB 1500
330 GOTO 160
400 REM Turn right 90 degrees and go forward
405 PRINT "Turn right 90 degrees, go forward"
410 GOSUB 1300
420 GOSUB 1300
430 GOSUB 1500
440 GOTO 160
500 REM Turn right 45 degrees and go forward
505 PRINT "Turn right 45 degrees, go forward"
510 GOSUB 1300
520 GOSUB 1500
530 GOTO 160
600 REM Go forward
605 PRINT "Go forward"
610 GOSUB 1500
620 GOSUB 1500
630 GOTO 160
700 REM Turn left 45 degrees and go forward
705 PRINT "Turn left 45 degrees, go forward"
710 GOSUB 1400
720 GOSUB 1500
730 GOTO 160
800 REM Turn left 90 degrees and go forward
805 PRINT "Turn left 45 degrees, go forward"
810 GOSUB 1400
820 GOSUB 1400
830 GOSUB 1500
840 GOTO 160
900 REM Back up and check environment again
905 PRINT "Backup and reevaluate"
910 GOSUB 1600
920 GOSUB 1600
930 GOTO 160
1000 REM Starting at the PING servo center position,
1010 REM check first at 45 degrees, then 90 degrees
1020 REM to the right, then the left for PING distance
1030 REM using variables A-E for PING.
1050 SERVO[15] = 550 : REM Start on the right side
1060 PAUSE 500 : a = PING[14] : REM Wait for movement, then PING
1080 SERVO[15] = 986 : REM Mid-right position
1090 PAUSE 500 : b = PING[14] : REM Wait for movement, then PING
1110 SERVO[15] = 1425 : REM Straight ahead
1120 PAUSE 500 : c = PING[14] : REM Wait for movement, then PING
1140 SERVO[15] = 1964 : REM Mid-left position
1150 PAUSE 500 : d = PING[14] : REM Wait for movement, then PING
1170 SERVO[15] = 2300 : REM Finish on the left side
1180 PAUSE 500 : e = PING[14] : REM Wait for movement, then PING
1200 SERVO[15] = 1425 : REM Center servo
1210 RETURN
1300 REM Turn to the right about 45 degrees
1310 SERVO[16] = 1688
1320 SERVO[17] = 1700
1330 PAUSE 500
1335 SERVO[16] = 1486 : SERVO[17] = 1508 : REM Stop
1340 RETURN
1400 REM Turn to the left about 45 degrees
1410 SERVO[16] = 1288
1420 SERVO[17] = 1300
1430 PAUSE 500
1435 SERVO[16] = 1486 : SERVO[17] = 1508 : REM Stop
1440 RETURN
1500 REM Go forward for about a second
1510 SERVO[16] = 1688
1520 SERVO[17] = 1300
1530 PAUSE 1000
1535 SERVO[16] = 1486 : SERVO[17] = 1508 : REM Stop
1540 RETURN
1600 REM Go backwards for about a second
1610 SERVO[16] = 1288
1620 SERVO[17] = 1700
1630 PAUSE 1000
1635 SERVO[16] = 1486 : SERVO[17] = 1508 : REM Stop
1640 RETURN
